----------------------------------------------------------------------------------
-- ECE 3401 Spring 2024: PA2 Matrix Multiplication State Machine
-- University of Connecticut
----------------------------------------------------------------------------------
library IEEE;
library work;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use work.matrix_pkg.all; --We are using our defined 3x3 matrix
 
entity smtest IS
end smtest;
 
architecture behavior OF smtest IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    component pa2
    port(
	   --Input signals
        A          : in matrix_2x4;
        B          : in matrix_4x3;
        clk, reset : in std_logic;
        start      : in std_logic; 
		
		--Output signals
		C            : inout matrix_2x3;
		ready        : out std_logic
	);
    end component;
 	
   -- Clock period definitions
   constant clk_period : time := 10 ns;
   
   --Test bench matrices for A, B, and C
   signal A : matrix_2x4;
   signal B : matrix_4x3;
   signal C : matrix_2x3;
                         
   -- This is our expected output of various A*B
   constant compC_1 : matrix_2x3 := ((41,  46,  51),
                                     (49,  56,  63)); 
                                   
   constant compC_2 : matrix_2x3 := ((0, 0, 0),
                                     (0, 0, 0)); 
   
   constant compC_3 : matrix_2x3 := ((15, 17, 18),
                                     (47, 49, 54)); 
   
   signal start      : std_logic;
   signal clk, reset : std_logic;
   signal ready      : std_logic;
   
begin
	-- Instantiate the Unit Under Test (UUT)
   uut: pa2 PORT MAP (
          A => A,
          B => B,
          start => start,
          reset => reset,
          clk => clk,
          C => C,
          ready => ready
        );
   
   clk_process: process
   begin
		clk <= '1';
		wait for clk_period/2;
		clk <= '0';
		wait for clk_period/2;
   end process;
   
   -- Stimulus process
   
   --MATRIX MULTIPLICATION #1 
   stim_proc: process
   begin 
    --Set the input matrix A
    A <= ((1, 0, 0, 4),
          (0, 0, 7, 0));
   
    --Set the input matrix B
    B <= ((1, 2, 3),
          (4, 5, 6),
          (7, 8, 9),
          (10,11,12));
    

    --Reset system state
    reset <= '1';
    wait for 0ns;
    reset <= '0';
                                         
    --Starting the SM by asserting the start bit
    start <= '1'; 
    wait for 2*clk_period;
    start <= '0';
    wait for clk_period;
    
    --Wait for "ready" to change, then capture the output 
    wait on ready; 
    
    --TODO: insert your verification checks and assertion with compC_1
    
    --Show output for a few cycles
    wait for 3*clk_period;
    
    
    --MATRIX MULTIPLICATION #2
    --Set the input matrix A
    A <= ((0, 0, 0, 0),
          (0, 0, 0, 0));
   
    --Set the input matrix B
    B <= ((3, 4, 0),
          (1, 4, 3),
          (0, 2, 3),
          (3 ,0, 2));
    
    --Reset system state
    reset <= '1';
    wait for 0ns;
    reset <= '0';
                                         
    --Starting the SM by asserting the start bit
    start <= '1'; 
    wait for 2*clk_period;
    start <= '0';
    wait for clk_period;
    
    --Wait for "ready" to change, then capture the output 
    wait on ready; 
    
    --TODO: insert your verification checks and assertion with compC_2
    
    --Show output for a few cycles
    wait for 3*clk_period;
    
    
    --MATRIX MULTIPLICATION #3
    --Set the input matrix A
    A <= ((1, 2, 3, 4),
          (5, 6, 7, 8));
   
    --Set the input matrix B
    B <= ((3, 3, 4),
          (4, 3, 3),
          (0, 0, 0),
          (1, 2, 2));
    
    --Reset system state
    reset <= '1';
    wait for 0ns;
    reset <= '0';
                                         
    --Starting the SM by asserting the start bit
    start <= '1'; 
    wait for 2*clk_period;
    start <= '0';
    wait for clk_period;
    
    --Wait for "ready" to change, then capture the output 
    wait on ready; 
    
    --For loop to compare the outputs
    
    --TODO: insert your verification checks and assertion with compC_3
    
    --Show output for a few cycles
    wait for 3*clk_period;
    
   end process;
   
END;
